/*
 * QtMoleculeItem_visibility.hpp
 *
 *  Created on: Jan 18, 2015
 *      Author: heber
 */

#ifndef QTMOLECULEITEM_VISIBILITY_HPP_
#define QTMOLECULEITEM_VISIBILITY_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "UIElements/Views/Qt4/MoleculeList/QtMoleculeItem.hpp"

class QtMoleculeItemFactory;

/** This class contains the visibility of a molecule and keeps it up to date.
 *
 */
class QtMoleculeItem_visibility : public QtMoleculeItem
{
  //!> only allow factory to instantiate items
  friend class QtMoleculeItemFactory;

  QtMoleculeItem_visibility(
      const molecule * const _mol,
      emitDirtyState_t _emitDirtyState) :
        QtMoleculeItem(_mol, channellist_visibility, QtMoleculeItem::DoesNotMove, _emitDirtyState)
  {
    setFlags(flags() | Qt::ItemIsUserCheckable);
    setCheckState(Qt::Unchecked);
    // cannot call pure virtual function in QtMoleculeItem's cstor
    internal_updateState();
  }

  /** Performs the update of the molecule's visibility.
   *
   */
  void internal_updateState()
  {}

  //!> notification channels of molecule specific to this molecule item, required for update
  static const QtMoleculeItem::channellist_t channellist_visibility;
};



#endif /* QTMOLECULEITEM_VISIBILITY_HPP_ */
